Multiscroll.Tool.Pan = function(parent) {
	this.parent = parent;	// to monitor clientX, clientY
	this.scaleFactor = 0;
	this.oldScaleFactor = 1;
	this.docOldLocation = null;
	this.markerNode = {
		document : null,
		background : null,
		thumbnail : null,
		window : null
	};
	this.docMarkerLeft = this.docMarkerTop = this.docMarkerWidth = this.docMarkerHeight = 0,
	this.winMarkerWidth = this.winMarkerHeight = 0;
	this.winMarkerLeft getter= function() { with (this) {
		return Math.min(docMarkerLeft + docMarkerWidth - winMarkerWidth, 
				Math.max(docMarkerLeft,
					parent.event.clientX - winMarkerWidth / 2));
	} };
	this.winMarkerTop getter= function() { with (this) {
		return Math.min(docMarkerTop + docMarkerHeight - winMarkerHeight, 
				Math.max(docMarkerTop,
					parent.event.clientY - winMarkerHeight / 2));
	} };
	this.scrollX getter= function() { with (this) {
		return (winMarkerLeft - docMarkerLeft) / scaleFactor;
	} };
	this.scrollX setter= function() { return null; };
	this.scrollY getter= function() { with (this) {
		return (winMarkerTop - docMarkerTop) / scaleFactor;
	} };
	this.scrollY setter= function() { return null; };
};

Multiscroll.Tool.Pan.wireframe = 0;
Multiscroll.Tool.Pan.textured = 1;
Multiscroll.Tool.Pan.thumbnail = 2;

Multiscroll.Tool.Pan.prototype = new Multiscroll.Tool({
	start : function(evt) {
		this.active = true;
		this.done = true;
		
		this.insertMarker(evt);
		window.setCursor(this.cursor);
	},
	stop : function(evt) {
		this.active = false;
		this.removeMarker(evt);
		window.setCursor("default");
	},
	execute : function(evt) {
		window.setCursor(this.cursor);
		
		this.markerNode.window.style.left = this.winMarkerLeft + "px";
		this.markerNode.window.style.top = this.winMarkerTop + "px";
		
		if (this.settings.appearance == Multiscroll.Tool.Pan.textured)
			for (var i = 0; i < 8; i++) {
				var el = this.markerNode.background[i];
				el.style.left = 1 + ((i+2)%8<3 ? this.docMarkerLeft : this.winMarkerLeft + ((i+6)%8<3 ? this.winMarkerWidth : 0)) + "px";
				el.style.top = (i%8<3 ? this.docMarkerTop : this.winMarkerTop + ((i+4)%8<3 ? this.winMarkerHeight : 0)) + "px";
				el.style.width = ((i+2)%8<3 ? this.winMarkerLeft - this.docMarkerLeft : ((i+6)%8<3 ? this.docMarkerLeft + this.docMarkerWidth - this.winMarkerLeft - this.winMarkerWidth : this.winMarkerWidth)) + "px";
				el.style.height = (i%8<3 ? this.winMarkerTop - this.docMarkerTop : ((i+4)%8<3 ? this.docMarkerTop + this.docMarkerHeight - this.winMarkerTop - this.winMarkerHeight : this.winMarkerHeight)) + "px";
			}
		this.client.frame.scrollTo(this.scrollX, this.scrollY);
	},
	insertMarker : function(evt) { with (this) {
		var docBox = client.document.getBoxObjectFor(client.document.documentElement);
		var el;

		clientX = evt.clientX;
		clientY = evt.clientY;
		var pageXOffset = client.frame.pageXOffset;
		var pageYOffset = client.frame.pageYOffset;
		var documentWidth = docBox.width;
		var documentHeight = docBox.height;
		windowWidth = Math.min(client.frame.innerWidth, documentWidth); // why are scrollbars included
		windowHeight = Math.min(client.frame.innerHeight, documentHeight); // in window.innerWidth?
		
		// magic formula - do the maths if you don't trust it!
		scaleFactor = 1;
		scaleFactor = Math.min(scaleFactor, 
			clientX / (windowWidth / 2 + pageXOffset));
		scaleFactor = Math.min(scaleFactor, 
			(windowWidth - 20 - clientX) / (documentWidth - windowWidth / 2 - pageXOffset));
		scaleFactor = Math.min(scaleFactor, 
			clientY / (windowHeight / 2 + pageYOffset));
		scaleFactor = Math.min(scaleFactor, 
			(windowHeight - 20 - clientY) / (documentHeight - windowHeight / 2 - pageYOffset));
		scaleFactor = Math.min(scaleFactor,
			settings.size / Math.min(documentWidth, documentHeight));
	
		docMarkerWidth = documentWidth * scaleFactor;
		docMarkerHeight = documentHeight * scaleFactor;
		winMarkerWidth = windowWidth * scaleFactor;
		winMarkerHeight = windowHeight * scaleFactor;

		docMarkerLeft = clientX - winMarkerWidth / 2 - pageXOffset * scaleFactor;
		docMarkerTop = clientY - winMarkerHeight / 2 - pageYOffset * scaleFactor;
	
		// document box
		if (settings.appearance == Multiscroll.Tool.Pan.thumbnail && Math.abs(Math.log(oldScaleFactor/scaleFactor)) < 0.1
				 && docOldLocation == client.document.location.href ) {
			el = thumbnailMarker;
			el.style.left = docMarkerLeft + "px";
			el.style.top = docMarkerTop + "px";
			el.style.width = docMarkerWidth + "px";
			el.style.height = docMarkerHeight + "px";
		} else {
			el = client.document.createElementNS("http://www.w3.org/1999/xhtml", "div");
			if (settings.appearance == Multiscroll.Tool.Pan.textured) {
				el.style.backgroundImage = "url('" + image.docCorner + "')";
				el.style.backgroundPosition = "top right";
				el.style.backgroundRepeat = "no-repeat";
			} else if (settings.appearance == Multiscroll.Tool.Pan.thumbnail) {
				el.style.overflow = "hidden";
				cloneElementToThumbnail(client.body, el, scaleFactor);
				thumbnailMarker = el;
				oldScaleFactor = scaleFactor;
				docOldLocation = client.document.location.href;
			}
			el.style.position = "fixed";
			el.style.left = docMarkerLeft + "px";
			el.style.top = docMarkerTop + "px";
			el.style.width = docMarkerWidth + "px";
			el.style.height = docMarkerHeight + "px";
			el.style.cursor = cursor;
			el.style.border = "2px solid gray";
		}
		client.body.appendChild(el);
		markerNode.document = el;
	
		// window box
		if (settings.appearance == Multiscroll.Tool.Pan.textured) {
			el = client.document.createElementNS("http://www.w3.org/1999/xhtml", "img");
			el.src = image.screen;
		} else {
			el = client.document.createElementNS("http://www.w3.org/1999/xhtml", "div");
		}
		el.style.position = "fixed";
		el.style.left = winMarkerLeft + "px";
		el.style.top = winMarkerTop + "px";
		el.style.width = winMarkerWidth + "px";
		el.style.height = winMarkerHeight + "px";
		el.style.cursor = cursor;
		el.style.border = "1px solid black";
	
		client.body.appendChild(el);
	
		markerNode.window = el;
	
		if (settings.appearance == Multiscroll.Tool.Pan.textured) {
			markerNode.background = [];
			for (var i = 0; i < 8; i++) {
				el = client.document.createElementNS("http://www.w3.org/1999/xhtml", "div");
				el.style.position = "fixed";
				el.style.left = 1 + ((i+2)%8<3 ? docMarkerLeft : winMarkerLeft + ((i+6)%8<3 ? winMarkerWidth : 0)) + "px";
				el.style.top = (i%8<3 ? docMarkerTop : winMarkerTop + ((i+4)%8<3 ? winMarkerHeight : 0)) + "px";
				el.style.width = ((i+2)%8<3 ? winMarkerLeft - docMarkerLeft : ((i+6)%8<3 ? docMarkerLeft + docMarkerWidth - winMarkerLeft - winMarkerWidth : winMarkerWidth)) + "px";
				el.style.height = (i%8<3 ? winMarkerTop - docMarkerTop : ((i+4)%8<3 ? docMarkerTop + docMarkerHeight - winMarkerTop - winMarkerHeight : winMarkerHeight)) + "px";
				el.style.cursor = cursor;
				el.style.backgroundImage = "url('" + image.docBody + "')";
				client.body.appendChild(el);
				markerNode.background[i] = el;
			}
		}
	} },
	removeMarker : function() { with (this) {
		if (markerNode.document != null)
			markerNode.document.parentNode.removeChild(markerNode.document);
	
		if (markerNode.window != null)
			markerNode.window.parentNode.removeChild(markerNode.window);
	
		if (settings.appearance == Multiscroll.Tool.Pan.textured)
			for (var i = 0; i < 8; i++)
				if (markerNode.background[i] != null) {
					markerNode.background[i].parentNode.removeChild(markerNode.background[i]);
					markerNode.background[i] = null;
				}
			
		markerNode.document = null;
		markerNode.window = null;
	
		if (settings.appearance == Multiscroll.Tool.Pan.textured)
			markerNode.background = null;
	} }
});
mergeObjects(Multiscroll.Tool.Pan.prototype, {
	createThumbnailInAdvance : function(evt) { with (this) {
		client = {
			frame : evt.originalTarget.ownerDocument.defaultView,
			document : evt.originalTarget.ownerDocument,
			body : (evt.originalTarget.ownerDocument.getElementsByTagName('body')[0])
						 ? evt.originalTarget.ownerDocument.getElementsByTagName('body')[0]
						 : evt.originalTarget.ownerDocument.getElementsByTagName('*')[0],
			window : evt.originalTarget.ownerDocument.contentWindow
		}
	
		if (client.body.nodeName == "window") return;
		if (client.document.location == null) return;
	
		var docBox = client.document.getBoxObjectFor(client.document.documentElement);
	
		var pageXOffset = client.frame.pageXOffset;
		var pageYOffset = client.frame.pageYOffset;
	
		var documentWidth = docBox.width;
		var documentHeight = docBox.height;
	
		var windowWidth = Math.min(client.frame.innerWidth, documentWidth); // why are scrollbars included
		var windowHeight = Math.min(client.frame.innerHeight, documentHeight); // in window.innerWidth?
	
		scaleFactor = 1;
		scaleFactor = Math.min(scaleFactor, 
			windowWidth / (windowWidth / 2 + pageXOffset));
		scaleFactor = Math.min(scaleFactor, 
			(windowWidth - 20) / (documentWidth - windowWidth / 2 - pageXOffset));
		scaleFactor = Math.min(scaleFactor, 
			windowHeight / (windowHeight / 2 + pageYOffset));
		scaleFactor = Math.min(scaleFactor, 
			(windowHeight - 20) / (documentHeight - windowHeight / 2 - pageYOffset));
		scaleFactor = Math.min(scaleFactor,
			this.settings.size / Math.min(documentWidth, documentHeight));
	
		docMarkerWidth = documentWidth * scaleFactor;
		docMarkerHeight = documentHeight * scaleFactor;
	
		if (Math.abs(Math.log(oldScaleFactor/scaleFactor)) > 0.1
				 || docOldLocation != client.document.location.href ) {
			var el = client.document.createElementNS("http://www.w3.org/1999/xhtml", "div");
			el.style.overflow = "hidden";
			this.cloneElementToThumbnail(client.body, el, scaleFactor);
			el.style.position = "fixed";
			el.style.width = docMarkerWidth + "px";
			el.style.height = docMarkerHeight + "px";
			el.style.cursor = cursor;
			el.style.border = "2px solid gray";
	
			markerNode.thumbnail = el;
			oldScaleFactor = this.scaleFactor;
			docOldLocation = client.document.location.href;
		}
	} },
	cloneElementToThumbnail : function(source, target, scale) {
		for (var i = 0; i < source.childNodes.length; i++) {
			target.appendChild(source.childNodes[i].cloneNode(true));
			scaleNodeRecursive(source.childNodes[i], target.childNodes[i], scale);
		}
		cs = client.frame.getComputedStyle(source, '');
		scaleProperty(target, cs, 'fontSize', 'font-size', scale);
		scaleProperty(target, cs, 'letterSpacing', 'letter-spacing', scale);
		scaleProperty(target, cs, 'lineHeight', 'line-height', scale);
		scaleProperty(target, cs, 'wordSpacing', 'word-spacing', scale);
		copyProperty(target, cs, 'backgroundColor', 'background-color');
		copyProperty(target, cs, 'backgroundImage', 'background-image');
		copyProperty(target, cs, 'backgroundRepeat', 'background-repeat');
	},
	scaleNodeRecursive : function(original, node, scale) {
		if (node.nodeName == "SCRIPT" || node.nodeName == "HR") {
			node.parentNode.replaceChild(client.document.createElementNS("http://www.w3.org/1999/xhtml", "script"), node);
		} else if (node.nodeType == 1) {multiscroll.
			scaleNode(original, node, scale);
			for (var i = 0; i < node.childNodes.length; i++) {
				if (node.childNodes[i].nodeType == 1)
			scaleNodeRecursive(original.childNodes[i], node.childNodes[i], scale);
			}
		}
	},
	arrScalableStyles : [
		'backgroundPosition', 'background-position',
		'borderSpacing', 'border-spacing',
		'borderTopWidth', 'border-top-width',
		'borderRightWidth', 'border-right-width',
		'borderBottomWidth', 'border-bottom-width',
		'borderLeftWidth', 'border-left-width',
		'bottom', 'bottom',
		'fontSize', 'font-size',
		'height', 'height',
		'left', 'left',
		'letterSpacing', 'letter-spacing',
		'lineHeight', 'line-height',
		'marginTop', 'margin-top',
		'marginRight', 'margin-right',
		'marginBottom', 'margin-bottom',
		'marginLeft', 'margin-left',
		'markerOffset', 'marker-offset',
		'maxHeight', 'max-height',
		'maxWidth', 'max-width',
		'minHeight', 'min-height',
		'minWidth', 'min-width',
		'outlineWidth', 'outline-width',
		'paddingTop', 'padding-top',
		'paddingRight', 'padding-right',
		'paddingBottom', 'padding-bottom',
		'paddingLeft', 'padding-left',
		'right', 'right',
		'size', 'size',
		'textIndent', 'text-indent',
		'textShadow', 'text-shadow',
		'top', 'top',
		'verticalAlign', 'vertical-align',
		'width', 'width',
		'wordSpacing', 'word-spacing'
	],
	scaleNode : function(original, node, scale) {
		cs = multiscroll.client.frame.getComputedStyle(original, '');	// we use original because nodes do not acquire
		if (node.nodeName == "TABLE") {		// position properties till they are flowed in
			if (!isNaN(node.cellPadding)) node.cellPadding *= scale;
			if (!isNaN(node.cellSpacing)) node.cellSpacing *= scale;
			if (!isNaN(node.border)) node.border *= scale;
			node.style.padding = '0px';	// Believe it or not, when these are set as CSS rules on a table they fail to 
			node.style.margin = '0px';	// show up in computedStyle - we can't discover their values, all we can do is kill.
		}
		for ( var i = 0; i < this.arrScalableStyles.length; i += 2 )
			scaleProperty(node, cs, this.arrScalableStyles[i], this.arrScalableStyles[i+1], scale);
	},
	scaleProperty : function(node, cs, propertyCased, property_dashed, scale) {
		property = cs.getPropertyValue(property_dashed);
		if ( property == '0px' || property == '' || property.slice(-1) == '%' ) return;
		value = (property == 'thin') ? 1 : (property == 'medium') ? 3 : (property == 'thick') ? 5 : Number(property.slice(0, -2));
		if ( value == 0 || isNaN(value) ) return;
		eval( "node.style." + propertyCased + "='" + value * scale + "px';" );
	},
	copyProperty : function(node, cs, propertyCased, property_dashed) {
		eval( "node.style." + propertyCased + "='" + cs.getPropertyValue(property_dashed) + "';" );
	}
});
